--[[
MultiTool Multi Boxing utilities inspired by smurfys MultiBoxer addon

Shouts to http://old.wowace.com/wiki/WelcomeHome_-_Your_first_Ace3_Addon

Extra special shouts to Allara and OrionShock for pointing me in the right direction RE: AceComm-3.0

Author: DigitalSorceress
Date: 2008/11/17
Version: 0.2.00
]]

-- Some initialization of our happy local vars
local myName = "MultiTool"
--local myVersion = GetAddonMetadata(myName, "Version")
local myVersion = "v0.2.00"

local totalBagSlots = 0
local totalFreeBagSlots = 0
local totalUsedBagSlots = 0
local totalFreeQuestLogSlots = 0

MultiTool = LibStub("AceAddon-3.0"):NewAddon("MultiTool", "AceConsole-3.0","AceComm-3.0","AceEvent-3.0","AceSerializer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("MultiTool")

-- ------------------------------------------------
-- CONFIGURATION STUFF
-- ------------------------------------------------
-- Holds our configuration options
local options = {
  name = "MultiTool",
  handler = MultiTool,
  type = 'group',
  args = {
   debugFlag = {
      type = "toggle",
      name = L["DEBUGGING_NAME"],
      desc = L["DEBUGGING_DESC"],
      get = "getDebugFlag",
      set = "setDebugFlag"
    },
   taxiFlag = {
      type = "toggle",
      name = L["TAXI_NAME"],
      desc = L["TAXI_DESC"],
      get = "getTaxiFlag",
      set = "setTaxiFlag"
    },
   gossipFlag = {
      type = "toggle",
      name = L["GOSSIP_NAME"],
      desc = L["GOSSIP_DESC"],
      get = "getGossipFlag",
      set = "setGossipFlag"
    },   
   rewardFlag = {
      type = "toggle",
      name = L["REWARD_CLONE_NAME"],
      desc = L["REWARD_CLONE_DESC"],
      get = "getRewardFlag",
      set = "setRewardFlag"
    },   
    repairFlag= {
      type = "toggle",
      name = L["AUTO_REPAIR_NAME"],
      desc = L["AUTO_REPAIR_DESC"],
      get = "getRepairFlag",
      set = "setRepairFlag"
    },
   monitorBag = {
      type = "group",
      name = L["BAG_MONITOR_NAME"],
      args = {
        bagFlag = {
          type = "toggle",
          name = L["BAG_FLAG_NAME"],
          desc = L["BAG_FLAG_DESC"],
          get = "getBagFlag",
          set = "setBagFlag"
        },
        bagWarn = {
          type = "input",
          name = L["BAG_WARN_NAME"],
          desc = L["BAG_WARN_DESC"],
          get = "getBagWarn",
          set = "setBagWarn"
        }
      }
    }, 
   monitorQuestLog = {
      type = "group",
      name = L["QUEST_LOG_MONITOR_NAME"],
      args = {
        questLogFlag = {
          type = "toggle",
          name = L["QUEST_LOG_FLAG_NAME"],
          desc = L["QUEST_LOG_FLAG_DESC"],
          get = "getQuestLogFlag",
          set = "setQuestLogFlag"
        },
        questLogWarn = {
          type = "input",
          name = L["QUEST_LOG_WARN_NAME"],
          desc = L["QUEST_LOG_WARN_DESC"],
          get = "getQuestLogWarn",
          set = "setQuestLogWarn"
        }
      }
    }, 
   duelFlag = {
      type = "toggle",
      name = L["DUELING_NAME"],
      desc = L["DUELING_DESC"],
      get = "getDuelFlag",
      set = "setDuelFlag"
    },
    vendJunkFlag= {
      type = "toggle",
      name = L["VEND_JUNK_NAME"],
      desc = L["VEND_JUNK_DESC"],
      get = "getVendJunkFlag",
      set = "setVendJunkFlag"
    }
  }
}


--
-- Set the default profile if they don't have one
--
local defaults = {
  profile = {
    debugFlag = false,
    duelFlag = true,
    taxiFlag = true,
    gossipFlag = true,
    rewardFlag = false,
    repairFlag = true,
    bagFlag = true,
    bagWarn = 5,
    questLogFlag = true,
    questLogWarn = 5,
    vendJunkFlag = false,
    repairFlag = true
  }
}


--
-- Field handlers
--

-- DEBUG
function MultiTool:getDebugFlag(info)
  return self.db.profile.debugFlag
end
  
function MultiTool:setDebugFlag(info, value)
  self.db.profile.debugFlag = value
end

-- DUEL
function MultiTool:getDuelFlag(info)
  return self.db.profile.duelFlag
end
  
function MultiTool:setDuelFlag(info, value)
  self.db.profile.duelFlag = value
end

-- TAXI
function MultiTool:getTaxiFlag(info)
  return self.db.profile.taxiFlag
end
  
function MultiTool:setTaxiFlag(info, value)
  self.db.profile.taxiFlag = value
end

-- QUEST GOSSIP
function MultiTool:getGossipFlag(info)
  return self.db.profile.gossipFlag
end
  
function MultiTool:setGossipFlag(info, value)
  self.db.profile.gossipFlag = value
end

-- REWARD CLONE
function MultiTool:getRewardFlag(info)
  return self.db.profile.rewardFlag
end
  
function MultiTool:setRewardFlag(info, value)
  self.db.profile.rewardFlag = value
end

-- REPAIR
function MultiTool:getRepairFlag(info)
  return self.db.profile.repairFlag
end
  
function MultiTool:setRepairFlag(info, value)
  self.db.profile.repairFlag = value
end

-- BAG MONITORING
function MultiTool:getBagFlag(info)
  return self.db.profile.bagFlag
end
  
function MultiTool:setBagFlag(info, value)
  self.db.profile.bagFlag = value
end

function MultiTool:getBagWarn(info)
  return self.db.profile.bagWarn
end
  
function MultiTool:setBagWarn(info, value)
  self.db.profile.bagWarn = value
end

-- QUEST LOG MONITORING
function MultiTool:getQuestLogFlag(info)
  return self.db.profile.questLogFlag
end
  
function MultiTool:setQuestLogFlag(info, value)
  self.db.profile.questLogFlag = value
end

function MultiTool:getQuestLogWarn(info)
  return self.db.profile.questLogWarn
end
  
function MultiTool:setQuestLogWarn(info, value)
  self.db.profile.questLogWarn = value
end

-- AUTO MERCHANT
function MultiTool:getRepairFlag(info)
  return self.db.profile.repairFlag
end
  
function MultiTool:setRepairFlag(info, value)
  self.db.profile.repairFlag = value
end

function MultiTool:getVendJunkFlag(info)
  return self.db.profile.vendJunkFlag
end
  
function MultiTool:setVendJunkFlag(info, value)
  self.db.profile.vendJunkFlag = value
end

--
-- Chat Command setup
-- 
function MultiTool:ChatCommand(input)
  if not input or input:trim() == "" then
    -- This would use the Ace config gui
    -- LibStub("AceConfigDialog-3.0"):Open("MultiTool")
    -- This uses the Bliz options pane instead
    InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
  else
    LibStub("AceConfigCmd-3.0").HandleCommand(MultiTool, L["SHORT_SLASH_CMD"], L["FULL_SLASH_CMD"], input)
  end
end


-- ------------------------------------------------
-- BASIC REQUIRED FUNCTIONS
-- ------------------------------------------------

-- Called when the addon is loaded
function MultiTool:OnInitialize()
  -- Using the AceDB for storage of our info
  self.db = LibStub("AceDB-3.0"):New("MultiToolDB", defaults, "Default")

  -- main options table stuff
  LibStub("AceConfig-3.0"):RegisterOptionsTable("MultiTool", options)
  -- adding to Blizzard options configuration
  self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("MultiTool", "MultiTool")
  -- registering the slash commands
  self:RegisterChatCommand(L["FULL_SLASH_CMD"], "ChatCommand")
  self:RegisterChatCommand(L["SHORT_SLASH_CMD"], "ChatCommand")
  self:RegisterChatCommand("help", "helpDialog")
  
  self:RegisterComm("MultiTool","OnCommReceived")
end


-- Called when the addon is enabled
function MultiTool:OnEnable()
  -- Register Duel requested event so we can swat em
  self:RegisterEvent("DUEL_REQUESTED", "duelRequested")
  -- Register merchant Show for autorepair and auto sell
	self:RegisterEvent("MERCHANT_SHOW", "autoMerchant")
	-- register bag_update to keep track of bag space
  self:RegisterEvent("BAG_UPDATE", "updateBagSpace")
  -- register quest log update so we can track that
  self:RegisterEvent("QUEST_LOG_UPDATE", "updateQuestLogSpace")

	
	-- Taxi hook
	hooksecurefunc("TakeTaxiNode",takeTaxiNodeHook)

  -- Quest gossip hooks
	hooksecurefunc("SelectGossipAvailableQuest", selectGossipAvailableQuestHook)
	hooksecurefunc("SelectGossipActiveQuest", selectGossipActiveQuestHook)
	hooksecurefunc("SelectGossipOption", selectGossipOptionHook)

	hooksecurefunc("SelectAvailableQuest", selectAvailableQuestHook)
	hooksecurefunc("SelectActiveQuest", selectActiveQuestHook)

	hooksecurefunc("AcceptQuest", acceptQuestHook)
	hooksecurefunc("CompleteQuest", completeQuestHook)
	hooksecurefunc("GetQuestReward", getQuestRewardHook)
	hooksecurefunc("DeclineQuest", declineQuestHook)

  -- update our bag count
  self:updateBagSpace()
  -- update our quest log count
  self:updateQuestLogSpace()

  if (self.db.profile.debugFlag) then
    self:Print(myName.." v"..myVersion.." ENABLED!")
  end
end


-- Called when the addon is disabled
function MultiTool:OnDisable()
  --
end


-- ------------------------------------------------
-- EVENT HANDLERS
-- ------------------------------------------------

--
-- Auto Decline Duels
--
function MultiTool:duelRequested(challenger)
	if (self.db.profile.duelFlag) then
    if (self.db.profile.debugFlag) then
      self:Print("Duel denied from challenger:"..challenger)
    end -- debug
    CancelDuel();
  	StaticPopup_Hide("DUEL_REQUESTED");
	end -- if duelFlag
end -- function duelRequested()


--
-- Wrapper for auto repair and auto sell gray
--
function MultiTool:autoMerchant()
  -- let's sell first - just in case we need repair money
  self:autoSellJunk()
  -- Now, repair all
  self:autoRepair()
end


--
-- Auto Sell Junk - Inspired by CrapAway
--
function MultiTool:autoSellJunk()
  if (self.db.profile.vendJunkFlag) then
    -- iterate through bags
    for bag = 0, 4 do
      -- need to know the number of slots we have to look in
  		local numSlots = GetContainerNumSlots(bag)

      -- we have slots
  		if (numSlots > 0) then
        -- go through items in bag
        for slot = 1, numSlots + 1 do
          local currentItem = GetContainerItemLink(bag,slot)
          if (currentItem ~= nil) then
            -- Gotta get the item info using the link
            
            -- local currentItemQuality = Select(3, GetItemInfo(currentItem))
            local currentItemQuality = nil
             _,_,currentItemQuality,_,_,_,_,_,_,_ = GetItemInfo(currentItem)
            if (currentItemQuality ~= nil and currentItemQuality == 0) then
              UseContainerItem(bag,slot)
            end
          end
        end
  		end
  	end -- end for loop
  end -- if vendJunkFlag
end -- autoSellJunk()


--
-- Auto Repair All
--
function MultiTool:autoRepair()
	if (self.db.profile.repairFlag) then
    if (self.db.profile.debugFlag) then
      self:Print("Auto Repair Engaged")
    end -- debug
    if (CanMerchantRepair()) then
			RepairAllItems();
		end
	end -- if duelFlag
end -- function duelRequested()


--
-- Bag total/free updater  (Based on BagSlots addon)
--
function MultiTool:updateBagSpace()
  -- to be efficient, only bother if we are flagged for it
	if (self.db.profile.bagFlag) then
    if (self.db.profile.debugFlag) then
      self:Print("updateBagSpace() ENGAGED")
      self:Print("  totalBagSlots: "..tostring(totalBagSlots))
      self:Print("  totalFreeBagSlots: "..tostring(totalFreeBagSlots))
      self:Print("  totalUsedBagSlots: "..tostring(totalUsedBagSlots))
    end -- debug

    local sendWarning = false
    local tmp_totalBagSlots = 0
    local tmp_totalFreeBagSlots = 0
    local tmp_totalUsedBagSlots = 0
  
    -- go through bags and add each to the totals
  	for bag = 0, 4 do
      if (self.db.profile.debugFlag) then
        self:Print("Getting slots for bag "..tostring(bag))
      end
      
  		local numSlots = GetContainerNumSlots(bag)

  		if (numSlots > 0) then
    		tmp_totalBagSlots = tmp_totalBagSlots + numSlots
  			local freeSlots = GetContainerNumFreeSlots(bag)
  			tmp_totalFreeBagSlots = tmp_totalFreeBagSlots + freeSlots
  			local usedSlots = numSlots - freeSlots
  			tmp_totalUsedBagSlots = tmp_totalUsedBagSlots + usedSlots

        if (self.db.profile.debugFlag) then
          self:Print("Bag "..tostring(bag)..": has slots")
          self:Print("  numSlots: "..tostring(numSlots))
          self:Print("  tmp_totalBagSlots: "..tostring(tmp_totalBagSlots))
          self:Print("  freeSlots: "..tostring(freeSlots))
          self:Print("  tmp_totalFreeBagSlots: "..tostring(tmp_totalFreeBagSlots))
          self:Print("  tmp_totalUsedBagSlots: "..tostring(tmp_totalUsedBagSlots))
        end
      else
        if (self.db.profile.debugFlag) then
          self:Print("Bag "..tostring(bag)..": not present")
        end
  		end
  	end -- end for loop

    -- check to see if this update is gain or loss of free slots
    if (tmp_totalFreeBagSlots == 0) then
      -- NO SPACE! Send Warning
      sendWarning = true
    elseif (tmp_totalFreeBagSlots < totalFreeBagSlots) then
      -- we went DOWN... but if we already crossed threshold and send warning, don't do again
      -- compare number to alert - ONLY send message if we JUST crossed threshhold (==)
      if (self.db.profile.bagWarn == tmp_totalFreeBagSlots) then
        sendWarning = true
      end
    end
    
    -- Send the warning message if we have one
    if (sendWarning) then 
      local prefix = "MultiTool"
      local msg = {
        op = "BAG_WARN",
        free_space = tmp_totalFreeBagSlots
      }
      local text = self:Serialize(msg)
      local distribution = "RAID"
      local sender = player
      local prio = "ALERT"

      -- rpcCommandSender adds checking of the noComm value before sending
      self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
    end -- if sendWarning
    
    -- last thing:: Update the addon's copy of the bag levels
    totalBagSlots = tmp_totalBagSlots     
    totalFreeBagSlots = tmp_totalFreeBagSlots    
    totalUsedBagSlots = tmp_totalUsedBagSlots   
	end -- end if bagFlag
end -- end of funcction


--
-- Quest Log total/free updater
--
function MultiTool:updateQuestLogSpace()
  -- to be efficient, only bother if we are flagged for it
	if (self.db.profile.questLogFlag) then
    -- if they ever up the num of quests available...
    local constant_questLogSize = 25
    
    local sendWarning = false
    local tmp_totalQuestLogEntries = 0
    local tmp_totalFreeQuestLogSlots = 0

    tmp_totalQuestLogEntries = GetNumQuestLogEntries()
    tmp_totalFreeQuestLogSlots = constant_questLogSize - tmp_totalQuestLogEntries

    -- check to see if this update is gain or loss of free slots
    if (tmp_totalFreeQuestLogSlots == 0) then
      -- NO SPACE! Send Warning
      sendWarning = true
    elseif (tmp_totalFreeQuestLogSlots < totalFreeQuestLogSlots) then
      -- we went DOWN... but if we already crossed threshold and send warning, don't do again
      -- compare number to alert - ONLY send message if we JUST crossed threshhold (==)
      if (self.db.profile.questLogWarn == tmp_totalFreeQuestLogSlots) then
        sendWarning = true
      end
    end
    
    -- Send the warning message if we have one
    if (sendWarning) then 
      local prefix = "MultiTool"
      local msg = {
        op = "QUEST_LOG_WARN",
        free_space = tmp_totalFreeQuestLogSlots
      }
      local text = self:Serialize(msg)
      local distribution = "RAID"
      local sender = player
      local prio = "NORMAL"

      -- rpcCommandSender adds checking of the noComm value before sending
      self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
    end -- if sendWarning
    
    -- last thing:: Update the addon's copy of the freeSlot levels
    totalFreeQuestLogSlots = tmp_totalFreeQuestLogSlots    
	end -- end if questLogFlag
end -- end of funcction

-- ------------------------------------------------
-- HOOKED FUNCTIONS
-- ------------------------------------------------

--
-- Quest Functions
--
function selectGossipActiveQuestHook(index, noComm)
  local self = MultiTool
  if (self.db.profile.gossipFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "QUEST_GOSSIP",
      sub_op = "SELECT_GOSSIP_ACTIVE",
      index = index
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("gossipFlag is false... not sending comms")
    end
  end
end


function getQuestRewardHook(index, noComm)
  local self = MultiTool
  if (self.db.profile.gossipFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "QUEST_GOSSIP",
      sub_op = "GET_QUEST_REWARD",
      index = index
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("gossipFlag is false... not sending comms")
    end
  end
end


function selectAvailableQuestHook(index, noComm)
  local self = MultiTool
  if (self.db.profile.gossipFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "QUEST_GOSSIP",
      sub_op = "SELECT_AVAILABLE",
      index = index
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("gossipFlag is false... not sending comms")
    end
  end
end


function selectGossipAvailableQuestHook(index, noComm)
  local self = MultiTool
  if (self.db.profile.gossipFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "QUEST_GOSSIP",
      sub_op = "SELECT_GOSSIP_AVAILABLE",
      index = index
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("gossipFlag is false... not sending comms")
    end
  end
end


function selectGossipOptionHook(index, noComm)
  local self = MultiTool
  if (self.db.profile.gossipFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "QUEST_GOSSIP",
      sub_op = "SELECT_OPTION",
      index = index
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("gossipFlag is false... not sending comms")
    end
  end
end


function selectActiveQuestHook(index, noComm)
  local self = MultiTool
  if (self.db.profile.gossipFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "QUEST_GOSSIP",
      sub_op = "SELECT_ACTIVE",
      index = index
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("gossipFlag is false... not sending comms")
    end
  end
end


function acceptQuestHook(noComm)
  local self = MultiTool
  if (self.db.profile.gossipFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "QUEST_GOSSIP",
      sub_op = "ACCEPT_QUEST"
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("gossipFlag is false... not sending comms")
    end
  end
end


function completeQuestHook(noComm)
  local self = MultiTool
  if (self.db.profile.gossipFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "QUEST_GOSSIP",
      sub_op = "COMPLETE_QUEST"
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("gossipFlag is false... not sending comms")
    end
  end
end


function declineQuestHook(noComm)
  local self = MultiTool
  if (self.db.profile.gossipFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "QUEST_GOSSIP",
      sub_op = "DECLINE_QUEST"
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("gossipFlag is false... not sending comms")
    end
  end
end


--
-- Taxi following
--
function takeTaxiNodeHook(index, noComm) 
  local self = MultiTool
    
  -- Only use the additional functionality IF taxiFlag is true
  if (self.db.profile.taxiFlag) then
    local prefix = "MultiTool"
    local msg = {
      op = "TAKETAXI",
      node = index,
      nodeName = TaxiNodeName(index)
    }
    local text = self:Serialize(msg)
    
    local distribution = "RAID"
    local sender = player
    local prio = "ALERT"   
    
    -- rpcCommandSender adds checking of the noComm value before sending
    self:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  else
    if (self.db.profile.debugFlag) then
      self:Print("taxiFlag is false... not sending comms")
    end
  end
end -- end function takeTaxiNodeHook


-- ------------------------------------------------
-- COMM-BASED FUNCTIONS
-- ------------------------------------------------

--
-- Handles received commands
--
function MultiTool:OnCommReceived(prefix, message, distribution, sender)
  local success, o = self:Deserialize(message)
  if (self.db.profile.debugFlag) then
  	self:Print("comm received")
  	self:Print("  prefix: "..prefix)
  	self:Print("  message: "..message)
  	self:Print("  distribution: "..distribution)
  	self:Print("  sender: "..sender)
  	self:Print("  player: "..UnitName("player"))
  	self:Print("  Deserialize success: "..tostring(success))
  	self:Print("  Deserialize o: "..tostring(o))
  	--self:Print("  priority: "..priority)
  end -- end if debugFlag

  -- don't do anyting if we could not deserialize
  if (success == false) then
    if (self.db.profile.debugFlag) then
      self:Print("Failed to deserialize the message - OnCommReceived can not process any further")
    end -- if debugFlag
    return -- Failure
  else
    --
    -- TEMPLATE - Not actually used
    --
    if (o["op"] == "foo") then
      if (self.db.profile.actionFlag) then
        -- Put any extra conditions here
        if ("someCondition" == "some value") then
          if (self.db.profile.debugFlag) then
            -- debug statements for it here
          end -- ending debug

          return -- do nothing
        else
          -- do the action
          if (self.db.profile.debugFlag) then
            self:Print("OPNAME op engaged")
          end -- ending debug
          -- actual command such as TakeTaxiNode(o["node"], "noComm")
        end -- ending extra conditions
      end -- if gossipFlag
    end -- end if op == foo
    
    --
    -- Bag Space Warning
    --
    if (o["op"] == "BAG_WARN") then
      if (self.db.profile.bagFlag) then
        -- Only do the warning message IF it's empty bag message or if it's AT the threshold
        if (o["free_slots"] == 0 or o["free_slots"] == self.db.profile.bagWarn) then
          if (self.db.profile.debugFlag) then
            self:Print("BAG_WARN op engaged")
            self:Print("  conditions met - displaying warning")
          end -- ending debug
          
          -- need to localize this
          local tmp_msgText = string.format(L["BAG_WARN_MSG"], sender, o["free_slots"])
          
          -- DO THE WARNING
          UIErrorsFrame:AddMessage(self.tmp_msgText, 1.0, 1.0, 1.0, 5.0)

        end
      end -- end of flagCheck
    end -- end if op == BAG_WARN

    --
    -- Quest Log Warning
    --
    if (o["op"] == "QUEST_LOG_WARN") then
      if (self.db.profile.questLogFlag) then
        -- Only do the warning message IF it's empty bag message or if it's AT the threshold
        if (o["free_slots"] == 0 or o["free_slots"] == self.db.profile.questLogWarn) then
          if (self.db.profile.debugFlag) then
            self:Print("QUEST_WARN op engaged")
            self:Print("  conditions met - displaying warning")
          end -- ending debug
          
          -- need to localize this
          local tmp_msgText = string.format(L["QUEST_LOG_WARN_MSG"], sender, o["free_slots"])
          
          -- DO THE WARNING
          UIErrorsFrame:AddMessage(self.tmp_msgText, 1.0, 1.0, 1.0, 5.0)

        end
      end -- end of flagCheck
    end -- end if op == BAG_WARN

    --
    -- Quest Gossip handler for cloning actions at quest givers
    --
    if (o["op"] == "QUEST_GOSSIP") then
      if (self.db.profile.gossipFlag) then
        -- Put global quest gossip checks here
        if ("someCondition" == "some bad value") then
          -- conditions mean we DON'T do anything
          if (self.db.profile.debugFlag) then
            -- debug statements for it here
            self:Print("Global QUEST_GOSSIP global condition failed - not doing anything")
          end -- ending debug

          return -- do nothing
        else
          -- do the action
          if (self.db.profile.debugFlag) then
            self:Print("QUEST_GOSSIP global conditions succeded - parsing subcommands")
          end -- ending debug
          
          if (o["sub_op"] == "SELECT_GOSSIP_AVAILABLE") then
            -- tacking on noComm so we don't cause message storm
         		SelectGossipAvailableQuest(o["index"], "noComm")
          elseif (o["sub_op"] == "SELECT_AVAILABLE") then
            -- tacking on noComm so we don't cause message storm
         		SelectAvailableQuest(o["index"], "noComm")
          elseif (o["sub_op"] == "SELECT_OPTION") then
            -- tacking on noComm so we don't cause message storm
		        SelectGossipOption(o["index"], "noComm");
          elseif (o["sub_op"] == "SELECT_ACTIVE") then
            -- tacking on noComm so we don't cause message storm
		        SelectActiveQuest(o["index"], "noComm");
          elseif (o["sub_op"] == "ACCEPT_QUEST") then
            -- tacking on noComm so we don't cause message storm
		        AcceptQuest("noComm")
          elseif (o["sub_op"] == "GET_QUEST_REWARD") then
            -- This one's special.. using logic from QuestGuru to make sure we
            -- don't allow cloning of reward choices
            if (self.db.profile.rewardFlag or GetNumQuestChoices() < 2) then
              if (self.db.profile.debugFlag) then
                self:Print(tostring(GetNumQuestChoices()).." choice - ok to run")
              end 
              -- tacking on noComm so we don't cause message storm
    		      GetQuestReward(o["index"],"noComm")	  
            else
              if (self.db.profile.debugFlag) then
                self:Print(tostring(GetNumQuestChoices()).." choices - Blocking getQuestReward")
              end
            end
          elseif (o["sub_op"] == "SELECT_GOSSIP_ACTIVE") then
            -- tacking on noComm so we don't cause message storm
		        SelectGossipActiveQuest(o["index"], "noComm")
          elseif (o["sub_op"] == "COMPLETE_QUEST") then
            -- tacking on noComm so we don't cause message storm
		        CompleteQuest("noComm")
          elseif (o["sub_op"] == "DECLINE_QUEST") then
            -- tacking on noComm so we don't cause message storm
		        DeclineQuest("noComm")
          end


        end -- ending extra conditions
      end -- if gossipFlag
    end -- end if op == foo
    
    --
    -- TAKETAXI
    --
    if (o["op"] == "TAKETAXI") then

      -- Only continue IF the taxiFlag is true
      if (self.db.profile.taxiFlag) then
  
      -- Ok, This is a BIG  bunch of stuff needed to stop a message storm
      -- the idea here is that we do NOT want to continue to try to take taxi
      -- (and thus re-calling the message send)
      -- IF we are the message originator or if the node we picked is invalid
      -- or if we're not currently at a taxi node or if we're currently ON a 
      -- taxi. 

        -- removed   taxiCommthrottle == true condition 
        if (  UnitOnTaxi("player") 
              or o["nodeName"] == "INVALID" 
              or o["nodeName"] ~= TaxiNodeName(o["node"])
              or sender == UnitName("player")
        ) 
        then
          -- safe to turn off the taxi comm throttle cuz we arent sending
          if (self.db.profile.debugFlag) then
            self:Print("TAKETAXI op NOT engaged")
            self:Print("  Am I on taxi? "..tostring(UnitOnTaxi("player")))
            self:Print("  actual node requested: "..tostring(o["node"]).." ("..o["nodeName"]..")")
            self:Print("  effective node requested: "..tostring(o["node"]).." ("..TaxiNodeName(o["node"])..")")
          end
          return -- DON'T DO ANYTHING: this stops a message storm
        else
          if (self.db.profile.debugFlag) then
            self:Print("TAKETAXI op engaged")
          end
          -- by passing the extra arg "noComm" to the takeTaxiNode, I think I solve the msg storms
          TakeTaxiNode(o["node"], "noComm")
        end -- if taxiCommTrhottle.. else
      else
        self:Print("taxiFlag is false... ignoring TAKETAXI request")
      end -- end if taxiFlag
    end -- end if op==TAKETAXI
  end -- if success==false
end -- function 


--
-- Wraps up Remote procedure call commands with a "nocomm" throttler
--
function MultiTool:rpcCommandSender(prefix, text, distribution, sender, prio, noComm)
  --debug
  if (self.db.profile.debugFlag) then
    self:Print("rpcCommandSender:: engaged")
    self:Print("  prefix: "..tostring(prefix))
    self:Print("  text: "..tostring(text))
    self:Print("  distribution: "..tostring(distribution))
    self:Print("  sender: "..tostring(sender))
    self:Print("  prio: "..tostring(prio))
    self:Print("  noComm flag: "..tostring(noComm))
  end

  -- New throttling - DO NOT send msg unless noComm is nil
  if (noComm) then
    if (self.db.profile.debugFlag) then
      self:Print("noComm flag IS set, NOT sending command")
    end
    -- Teh Gogglez - They do NOTHING!
    return
  else
    if (self.db.profile.debugFlag) then
      self:Print("noComm flag NOT set, sending command")
    end
    self:SendCommMessage(prefix, text, distribution, sender, prio)
  end
end

-- ------------------------------------------------
-- UTILITY FUNCTIONS
-- ------------------------------------------------
function MultiTool:helpCommand()
  self:Print("MultTool Help")
  self:Print("")
  self:Print("COMMANDS:")
  self:Print("  /MultiTool help - Show this help menu")
  self:Print("")
end
